Name:       thermostat
Version:    0.3
Release:    1%{?dist}
Summary:    A monitoring and serviceability tool for OpenJDK
License:    GPLv2+ with exceptions
URL:        http://icedtea.classpath.org/thermostat/
Source0:    http://icedtea.classpath.org/download/%{name}/%{name}-%{version}.tar.gz

Patch0:     fix-jfreechart-dep.patch
Patch1:     per-user-home.patch
Patch2:     fix-test-scopes.patch
Patch3:     ignore-missing-activator.patch
Patch4:     follow-lib-symlinks.patch

BuildArch:  noarch

BuildRequires:  java-devel >= 1:1.7.0
BuildRequires:  jpackage-utils

BuildRequires: maven
BuildRequires: maven-dependency-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-junit4

BuildRequires: felix-framework
BuildRequires: felix-osgi-core
BuildRequires: felix-osgi-compendium
BuildRequires: fusesource-pom
BuildRequires: jansi
BuildRequires: jfreechart
BuildRequires: jline2
BuildRequires: mongo-java-driver
BuildRequires: mongo-java-driver-bson
BuildRequires: netty

Requires: java >= 1:1.7.0
Requires: jpackage-utils

Requires: felix-framework
Requires: felix-osgi-core
Requires: felix-osgi-compendium
Requires: jansi
Requires: java-devel >= 1:1.7.0
Requires: jline2
Requires: jfreechart
Requires: mongodb
Requires: mongodb-server
Requires: mongo-java-driver
Requires: mongo-java-driver-bson
Requires: netty

%description
Thermostat is a monitoring and instrumentation tool for the Hotspot JVM,
with support for monitoring multiple JVM instances. The system is made
up of two processes: an Agent, which collects data, and a Client which
allows users to visualize this data. These components communicate via
a MongoDB-based storage layer. A pluggable agent framework allows for
collection of performance data beyond that which is included out of the
box. Support for corresponding pluggable GUI components for visualization
of additional data is pending.

%package javadoc
Summary:    Javadocs for %{name}
Group:      Documentation
Requires:   jpackage-utils

%description javadoc
This package contains the API documentation for %{name}

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
mvn-rpmbuild \
     -Dmaven.test.skip=true \
     -Dthermostat.home=%{_datarootdir}/%{name} \
     install javadoc:aggregate

# the build puts all depdency jars into distribution/target/lib as well
mv distribution/target/libs/thermostat-*jar .
rm -f distribution/target/libs/*jar
mv thermostat-*jar distribution/target/libs/

# fix path to java in scripts
sed -i 's|^JAVA=.*|JAVA="/usr/lib/jvm/java-openjdk/jre/bin/java"|' distribution/target/bin/thermostat
sed -i 's|^JAVA=.*|JAVA="/usr/lib/jvm/java-openjdk/jre/bin/java"|' distribution/target/bin/thermostat-client-gui

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/%{name}
mkdir -p %{buildroot}%{_datarootdir}

# move everything thermostat into /usr/share/thermostat
cp -a distribution/target %{buildroot}%{_datarootdir}/%{name}

# symlink dependencies into the right directory
build-jar-repository -s -p %{buildroot}%{_datarootdir}/%{name}/libs \
    felix/org.apache.felix.framework \
    felix/org.osgi.core \
    felix/org.osgi.compendium \
    commons-cli \
    hawtjni-runtime \
    jansi \
    jcommon \
    jfreechart \
    jline2 \
    mongo

ln -s /usr/lib/jvm/java-openjdk/lib/tools.jar \
    %{buildroot}%{_datarootdir}/%{name}/libs/

# binary names
ln -s %{_datarootdir}/%{name}/bin/thermostat-client-gui \
    %{buildroot}%{_bindir}/thermostat-client
ln -s %{_datarootdir}/%{name}/bin/thermostat \
    %{buildroot}%{_bindir}/thermostat

# move config files to /etc/ and symlink stuff under /usr/share/thermostat to it

mv %{buildroot}%{_datarootdir}/%{name}/etc/logging.properties \
    %{buildroot}%{_sysconfdir}/%{name}/
ln -s %{_sysconfdir}/%{name}/logging.properties \
    %{buildroot}%{_datarootdir}/%{name}/etc/logging.properties

mv %{buildroot}%{_datarootdir}/%{name}/agent/agent.properties \
    %{buildroot}%{_sysconfdir}/%{name}/agent.properties
ln -s %{_sysconfdir}/%{name}/agent.properties \
    %{buildroot}%{_datarootdir}/%{name}/agent/agent.properties

mv %{buildroot}%{_datarootdir}/%{name}/backends/system/backend.properties \
    %{buildroot}%{_sysconfdir}/%{name}/system-backend.properties
ln -s %{_sysconfdir}/%{name}/system-backend.properties \
    %{buildroot}%{_datarootdir}/%{name}/backends/system/backend.properties

# java docs
mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -a target/site/apidocs %{buildroot}%{_javadocdir}/%{name}

%files
%doc COPYING
%doc LICENSE
%doc README
%config(noreplace) %{_sysconfdir}/%{name}
%{_datarootdir}/%{name}
%{_bindir}/thermostat-client
%{_bindir}/thermostat

%files javadoc
%{_javadocdir}/%{name}

%changelog
* Thu Jul 12 2012 Omair Majid <omajid@redhat.com> - 0.3-1
- Update to upstream 0.3 release

* Sun May 06 2012 Omair Majid <omajid@redhat.com> - 0.2-0.20120506hg2140a7c81a4b
- Resolve RH813539
- Remove uneeded require on fusesource-pom
- Fix jar to use jline2 instead of jline

* Fri May 04 2012 Omair Majid <omajid@redhat.com> - 0.2-0.20120503hg2140a7c81a4b
- Update to pre-release upstream snapshot

* Mon Feb 13 2012 Omair Majid <omajid@redhat.com> - 0.1-1
- Updated description

* Tue Feb 07 2012 Omair Majid <omajid@redhat.com> - 0.1-1
- Intial package
